'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _requestPromise = require('request-promise');

var _requestPromise2 = _interopRequireDefault(_requestPromise);

var _debug = require('debug');

var _debug2 = _interopRequireDefault(_debug);

var _assert = require('assert');

var _assert2 = _interopRequireDefault(_assert);

var _url = require('url');

var _url2 = _interopRequireDefault(_url);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var debug = (0, _debug2.default)('geteventstore:removePersistentSubscription');
var baseErr = 'Remove persistent subscriptions - ';

var createRemoveRequest = function createRemoveRequest(name, streamName, config) {
	var urlObj = JSON.parse((0, _stringify2.default)(config));
	urlObj.pathname = '/subscriptions/' + streamName + '/' + name;

	var uri = _url2.default.format(urlObj);

	var request = {
		uri: uri,
		method: 'DELETE',
		json: true
	};
	return request;
};

exports.default = function (config) {
	return function () {
		var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(name, streamName) {
			var options, response;
			return _regenerator2.default.wrap(function _callee$(_context) {
				while (1) {
					switch (_context.prev = _context.next) {
						case 0:
							(0, _assert2.default)(name, baseErr + 'Persistent Subscription Name not provided');
							(0, _assert2.default)(streamName, baseErr + 'Stream Name not provided');

							options = createRemoveRequest(name, streamName, config);

							debug('', 'Options: %j', options);
							_context.next = 6;
							return (0, _requestPromise2.default)(options);

						case 6:
							response = _context.sent;

							debug('', 'Response: %j', response);
							return _context.abrupt('return', response);

						case 9:
						case 'end':
							return _context.stop();
					}
				}
			}, _callee, undefined);
		}));

		return function (_x, _x2) {
			return _ref.apply(this, arguments);
		};
	}();
};

module.exports = exports['default'];