'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _requestPromise = require('request-promise');

var _requestPromise2 = _interopRequireDefault(_requestPromise);

var _debug = require('debug');

var _debug2 = _interopRequireDefault(_debug);

var _assert = require('assert');

var _assert2 = _interopRequireDefault(_assert);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _url = require('url');

var _url2 = _interopRequireDefault(_url);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var debug = (0, _debug2.default)('geteventstore:getProjectionState');
var baseErr = 'Get Projection State - ';

exports.default = function (config) {
	var buildUrl = function buildUrl(name) {
		var urlObj = JSON.parse((0, _stringify2.default)(config));
		urlObj.pathname = '/projection/' + name + '/state';
		return _url2.default.format(urlObj);
	};

	return function () {
		var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(name, options) {
			var qs, urlOptions, response;
			return _regenerator2.default.wrap(function _callee$(_context) {
				while (1) {
					switch (_context.prev = _context.next) {
						case 0:
							(0, _assert2.default)(name, baseErr + 'Name not provided');

							qs = {};

							options = options || {};

							if (!_lodash2.default.isEmpty(options.partition)) qs.partition = options.partition;
							urlOptions = {
								uri: buildUrl(name),
								headers: {
									"Content-Type": "application/vnd.eventstore.events+json"
								},
								method: 'GET',
								json: true,
								qs: qs
							};


							debug('', 'Options: %j', options);
							_context.next = 8;
							return (0, _requestPromise2.default)(urlOptions);

						case 8:
							response = _context.sent;

							debug('', 'Response: %j', response);
							return _context.abrupt('return', response);

						case 11:
						case 'end':
							return _context.stop();
					}
				}
			}, _callee, undefined);
		}));

		return function (_x, _x2) {
			return _ref.apply(this, arguments);
		};
	}();
};

module.exports = exports['default'];