import req from 'request-promise';
import debugModule from 'debug';
import url from 'url';

const debug = debugModule('geteventstore:ping');

export default (config) => {
	const buildUrl = () => {
		const urlObj = JSON.parse(JSON.stringify(config));
		urlObj.pathname = '/ping';
		return url.format(urlObj);
	};

	return async() => {
		const options = {
			uri: buildUrl(),
			method: 'GET',
			timeout: config.timeout
		};

		debug('', 'Options: %j', options);
		const response = await req(options);
		debug('', 'Response: %j', response);
		return response;
	};
};