'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createConnection = require('./createConnection');

var _createConnection2 = _interopRequireDefault(_createConnection);

var _debug = require('debug');

var _debug2 = _interopRequireDefault(_debug);

var _bluebird = require('bluebird');

var _bluebird2 = _interopRequireDefault(_bluebird);

var _assert = require('assert');

var _assert2 = _interopRequireDefault(_assert);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var debug = (0, _debug2.default)('geteventstore:subscribeToStream');
var baseErr = 'Subscribe to Stream - ';

exports.default = function (config) {
	return function (streamName, onEventAppeared, onConfirmed, onDropped, resolveLinkTos) {
		return new _bluebird2.default(function (resolve, reject) {
			(0, _assert2.default)(streamName, baseErr + 'Stream Name not provided');

			resolveLinkTos = resolveLinkTos || false;

			var connection = (0, _createConnection2.default)(config, reject);
			var subscription = connection.subscribeToStream(streamName, resolveLinkTos, onEventAppeared, onConfirmed, onDropped, config.credentials);
			debug('', 'Subscription: %j', subscription);
			resolve(connection);
		});
	};
};

module.exports = exports['default'];