'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createConnection = require('./createConnection');

var _createConnection2 = _interopRequireDefault(_createConnection);

var _eventStoreClient = require('event-store-client');

var _eventStoreClient2 = _interopRequireDefault(_eventStoreClient);

var _debug = require('debug');

var _debug2 = _interopRequireDefault(_debug);

var _bluebird = require('bluebird');

var _bluebird2 = _interopRequireDefault(_bluebird);

var _assert = require('assert');

var _assert2 = _interopRequireDefault(_assert);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var debug = (0, _debug2.default)('geteventstore:subscribeToStreamFrom');
var baseErr = 'Subscribe to Stream From - ';

exports.default = function (config) {
	return function (streamName, fromEventNumber, onEventAppeared, onLiveProcessingStarted, onDropped, settings) {
		settings = settings || {};
		return new _bluebird2.default(function (resolve, reject) {
			(0, _assert2.default)(streamName, baseErr + 'Stream Name not provided');
			if (fromEventNumber === 0) fromEventNumber = undefined;

			var catchUpSettings = new _eventStoreClient2.default.CatchUpSubscription.Settings();

			if (settings.resolveLinkTos) catchUpSettings.resolveLinkTos = settings.resolveLinkTos;
			if (settings.maxLiveQueueSize) catchUpSettings.maxLiveQueueSize = settings.maxLiveQueueSize;
			if (settings.readBatchSize) catchUpSettings.readBatchSize = settings.readBatchSize;
			if (settings.debug) catchUpSettings.debug = settings.debug;

			var connection = (0, _createConnection2.default)(config, reject);
			var subscription = connection.subscribeToStreamFrom(streamName, fromEventNumber, config.credentials, onEventAppeared, onLiveProcessingStarted, onDropped, catchUpSettings);
			debug('', 'Subscription: %j', subscription);
			resolve(connection);
		});
	};
};

module.exports = exports['default'];