'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function (events) {
	return _lodash2.default.chain(events).filter('event').map(function (ev) {
		var event = ev.event;
		var link = ev.link;

		var mappedEvent = {
			streamId: event.eventStreamId,
			eventId: event.eventId,
			eventNumber: event.eventNumber,
			eventType: event.eventType,
			created: event.created,
			metadata: event.metadata.toString(),
			isJson: event.isJson,
			data: JSON.parse(event.data.toString())
		};

		if (!_lodash2.default.isEmpty(mappedEvent.metadata)) mappedEvent.metadata = JSON.parse(mappedEvent.metadata);

		if (link) {
			mappedEvent.positionStreamId = link.eventStreamId;
			mappedEvent.positionEventId = link.eventId;
			mappedEvent.positionEventNumber = link.eventNumber;
			mappedEvent.positionCreated = link.created;
		}
		return mappedEvent;
	}).value();
};

module.exports = exports['default'];